<style src="./Style.scss" lang="scss" scoped></style>
<script src="./Script.js"></script>

<template>
  <div class="nt-settings-multiple">
    <div class="m-portlet m-portlet--head-sm" style="border-radius: 4px;">
      <div
        class="m-portlet__head nt-settings-collapse-head"
        :id="'m-portlet__head-'+attribute_id"
        @click.prevent="toggleCollapse()"
      >
        <div style="width: 100%; display: flex ;cursor:pointer;">
          <div class="m-portlet__head-caption float-left" style="width: calc(100% - 30px)">
            <div class="m-portlet__head-title">
              <h5 class="m-portlet__head-text s--portlet__head-text" style="color:#444F78;">
                <!--<template>{{slot_option}}.</template>&nbsp;-->
                {{component}} khách hàng
              </h5>
            </div>
          </div>
          <div class="m-portlet__head-tools float-left" style="width: 30px;">
            <ul class="m-portlet__nav">
              <li class="m-portlet__nav-item">
                <a href="javascript:;" class="m-portlet__nav-link nt-settings-collapse-arrow">
                  <i
                    class="icon icon-down-arrow-1"
                    :id="'nt-settings-collapse-arrow-'+attribute_id"
                  ></i>
                </a>
              </li>
            </ul>
          </div>
        </div>
      </div>
      <div class="m-portlet__body nt-settings-collapse-body" :id="'m-portlet__body-'+attribute_id">
        <div class="nt-settings-collapse-head">
          <button
            class="nt-button nt-button-primary nt-button-top"
            data-toggle="modal"
            :data-target="'#addNewItem-'+attribute_id"
          >
            <i class="icon icon-plus"></i>
            <span class="nt-button-content">Thêm {{component.toLowerCase()}}</span>
          </button>
        </div>
        <div class="nt-settings-collapse-content" v-if="new_data_list && new_data_list.length > 0">
          <multiple-level-component
            :attribute_options="new_data_list"
            @delete_attribute_option="deleteLevel"
            @edit_attribute_option="showEditPopup"
            @sort_attribute_option="sortAttributeOptions"
          ></multiple-level-component>
        </div>
        <div class="nt-settings-collapse-content" v-else>
          <h4 class="nt-color-primary">Không tồn tại {{component.toLowerCase()}} khách hàng nào.</h4>
        </div>
        <div class="nt-settings-collapse-footer">
          <button class="nt-button nt-button-secondary" @click.prevent="resetData()">
            <span class="nt-button-content">Hủy bỏ</span>
          </button>
          <button
            :disabled="errors.any() || server_errors != '' || !isChange"
            :class="{'nt-button-disabled' : errors.any() || server_errors != '' || !isChange}"
            class="nt-button nt-button-warning"
            @click.prevent="completeSave()"
          >
            <span class="nt-button-content">Lưu lại</span>
          </button>
        </div>
      </div>
    </div>
    <div
      class="modal fade"
      data-backdrop="static"
      data-keyboard="false"
      :id="'addNewItem-'+attribute_id"
    >
      <div class="modal-dialog">
        <div class="modal-content">
          <div
            class="modal-header"
            style="background-image: linear-gradient(to right, #B82E45 , #7D438E);"
          >
            <div class="modal-text-header" style="width:100%; color:#FFFFFF">
              <i
                class="icon icon-child_organization-01 pull-left m--margin-right-10"
                style="font-size:24px"
              ></i>
              <h3 class="pull-left" style="margin-bottom:0px;font-size:24px; font-weight: 400;">
                Thêm cấp
                độ khách hàng
              </h3>
            </div>
            <button
              @click.prevent="closeAddNew()"
              type="button"
              style="color:#FFFFFF"
              class="close"
              data-dismiss="modal"
              aria-label="Close"
            >
              <span aria-hidden="true">
                <i class="icon icon-close"></i>
              </span>
            </button>
          </div>
          <div class="modal-body">
            <div
              class="form-group m-form__group"
              :class="{'has-danger': errors.has('addDataAttributeOption.nt-settings-add-attribute-option-title') || server_errors != ''}"
            >
              <label class="form-control-label nt-label">
                {{component}} khách hàng
                <span class="m--font-danger">*</span>
              </label>
              <s-input-text
                :data-vv-scope="'addDataAttributeOption'"
                v-model="addData.title"
                :id="'nt-settings-add-attribute-option-title'"
                :name="'nt-settings-add-attribute-option-title'"
                v-validate="{ required: true, max: 250 }"
                @keyup="checkUniqueLevel($event)"
              ></s-input-text>
              <div
                v-if="errors.has('addDataAttributeOption.nt-settings-add-attribute-option-title') || server_errors != ''"
                class="form-control-feedback m--font-danger"
              >
                <span v-if="server_errors !== ''">{{server_errors}}</span>
                <span
                  v-else
                >{{errors.first('addDataAttributeOption.nt-settings-add-attribute-option-title')}}</span>
              </div>
              <div v-else class="form-control-feedback m--font-danger">&nbsp;</div>
            </div>
            <div
              class="form-group m-form__group"
              :class="{ 'has-danger': errors.has('addDataAttributeOption.nt-settings-add-attribute-option-description') }"
            >
              <label class="form-control-label nt-label">Mô tả</label>
              <s-textarea
                :data-vv-scope="'addDataAttributeOption'"
                v-model="addData.description"
                :id="'nt-settings-add-attribute-option-description'"
                :name="'nt-settings-add-attribute-option-description'"
                v-validate="{ max: 1025 }"
                style="resize: vertical; max-height: 200px; min-height:100px;"
              ></s-textarea>
              <div
                v-if="errors.has('addDataAttributeOption.nt-settings-add-attribute-option-description')"
                class="form-control-feedback m--font-danger"
              >{{errors.first('addDataAttributeOption.nt-settings-add-attribute-option-description')}}</div>
              <div v-else class="form-control-feedback m--font-danger">&nbsp;</div>
            </div>
          </div>
          <div class="modal-footer" style="justify-content: start; background: #F4F5F9">
            <button
              :disabled="errors.any() || server_errors != ''"
              :class="{'nt-button-disabled' : errors.any() || server_errors != ''}"
              class="nt-button nt-button-warning"
              @click.prevent="saveAddNew()"
            >Lưu lại</button>
            <button
              @click.prevent="closeAddNew()"
              class="nt-button nt-button-secondary nt-button-border-secondary"
              data-dismiss="modal"
            >Hủy bỏ</button>
          </div>
        </div>
      </div>
    </div>
    <div
      class="modal fade"
      data-backdrop="static"
      data-keyboard="false"
      :id="'editItem-'+attribute_id"
      v-if="selectedItem"
    >
      <div class="modal-dialog">
        <div class="modal-content">
          <div
            class="modal-header"
            style="background-image: linear-gradient(to right, #B82E45 , #7D438E);"
          >
            <div class="modal-text-header" style="width:100%; color:#FFFFFF">
              <i
                class="icon icon-child_organization-01 pull-left m--margin-right-10"
                style="font-size:24px"
              ></i>
              <h3 class="pull-left" style="margin-bottom:0px;font-size:24px; font-weight: 400;">
                Sửa
                {{component.toLowerCase()}}
                khách hàng
              </h3>
            </div>
            <button
              @click="closeEditItem()"
              type="button"
              style="color:#FFFFFF"
              class="close"
              data-dismiss="modal"
              aria-label="Close"
            >
              <span aria-hidden="true">
                <i class="icon icon-close"></i>
              </span>
            </button>
          </div>
          <div class="modal-body">
            <div
              class="form-group m-form__group"
              :class="{'has-danger': errors.has('editDataAttributeOption.nt-settings-edit-attribute-option-title') || server_errors != ''}"
            >
              <label class="form-control-label nt-label">
                {{component}} khách hàng
                <span class="m--font-danger">*</span>
              </label>
              <s-input-text
                :data-vv-scope="'editDataAttributeOption'"
                v-model="selectedItem.option_value"
                :id="'nt-settings-edit-attribute-option-title'"
                :name="'nt-settings-edit-attribute-option-title'"
                v-validate="{ required: true, max: 250 }"
                @keyup="checkUniqueLevel($event, selectedItem.id)"
              ></s-input-text>
              <div
                v-if="errors.has('editDataAttributeOption.nt-settings-edit-attribute-option-title') || server_errors != ''"
                class="form-control-feedback m--font-danger"
              >
                <span v-if="server_errors !== ''">{{server_errors}}</span>
                <span
                  v-else
                >{{errors.first('editDataAttributeOption.nt-settings-edit-attribute-option-title')}}</span>
              </div>
              <div v-else class="form-control-feedback m--font-danger">&nbsp;</div>
            </div>
            <div
              class="form-group m-form__group"
              :class="{ 'has-danger': errors.has('editDataAttributeOption.nt-settings-edit-attribute-option-description') }"
            >
              <label class="form-control-label nt-label">Mô tả</label>
              <s-textarea
                :data-vv-scope="'editDataAttributeOption'"
                v-model="selectedItem.note"
                :id="'nt-settings-edit-attribute-option-description'"
                :name="'nt-settings-edit-attribute-option-description'"
                v-validate="{ max: 1025 }"
                style="resize: vertical; max-height: 200px; min-height:100px;"
              ></s-textarea>
              <div
                v-if="errors.has('editDataAttributeOption.nt-settings-edit-attribute-option-description')"
                class="form-control-feedback m--font-danger"
              >{{errors.first('editDataAttributeOption.nt-settings-edit-attribute-option-description')}}</div>
              <div v-else class="form-control-feedback m--font-danger">&nbsp;</div>
            </div>
          </div>
          <div class="modal-footer" style="justify-content: start; background: #F4F5F9">
            <button
              :disabled="errors.any() || server_errors != ''"
              :class="{'nt-button-disabled' : errors.any() || server_errors != ''}"
              class="nt-button nt-button-warning"
              @click.prevent="saveEditItem()"
            >Lưu lại</button>
            <button
              @click.prevent="closeEditItem()"
              class="nt-button nt-button-secondary nt-button-border-secondary"
              data-dismiss="modal"
            >Hủy bỏ</button>
          </div>
        </div>
      </div>
    </div>
    <div
      class="modal s--modal fade nt--modal-confirm-choice"
      data-backdrop="static"
      data-keyboard="false"
      :id="'deleteItem-'+attribute_id"
      v-if="deleteSelectedItem"
    >
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-body">
            <!--<h3 class="nt&#45;&#45;modal-confirm-choice-title">-->
            <!--Thông báo-->
            <!--</h3>-->
            <div class="nt--modal-confirm-choice-content">
              <div class="nt--modal-confirm-choice-content-title-top">
                <template v-if="deleteSelectedItem.count >= 0">
                  Bạn có chắc chắn muốn xóa {{component.toLowerCase()}} "
                  <span class="nt-color-warning">{{deleteSelectedItem.option_value}}</span>"?
                </template>
                <template v-else>
                  Xoá {{component.toLowerCase()}} "
                  <span class="nt-color-warning">{{deleteSelectedItem.option_value}}</span>"?
                </template>
              </div>

              <div class="nt--modal-confirm-choice-content-title-bottom">
                <template v-if="new_data_list.length > 1">
                  <template v-if="deleteSelectedItem.count > 0">
                    {{component}}
                    <span class="nt-color-warning">{{deleteSelectedItem.option_value}}</span> có
                    <span class="nt-color-warning">{{deleteSelectedItem.count}}</span> khách hàng đã
                    chọn.
                    <br />
                    Nếu xóa {{component.toLowerCase()}}, các khách hàng đã chọn ở
                    {{component.toLowerCase()}} này sẽ trở thành
                    <br />
                    khách hàng ở {{component.toLowerCase()}}
                    <span
                      class="nt-color-warning"
                      v-if="new_data_list && new_data_list.length > 1"
                    >
                      <template
                        v-if="isObjectExistInArray(new_data_list, deleteSelectedItem)"
                      >{{new_data_list[1].option_value}}</template>
                      <template v-else>{{new_data_list[0].option_value}}</template>
                    </span>
                    <span v-else>""</span>
                  </template>
                </template>

                <template
                  v-else
                >Nếu xóa {{component.toLowerCase()}} cuối cùng này, tất cả khách hàng sẽ không có {{component.toLowerCase()}}.</template>
              </div>
            </div>
          </div>
          <div class="modal-footer">
            <button
              class="nt-button nt-button-secondary nt-button-border-secondary m--margin-right-10"
              data-dismiss="modal"
            >Hủy bỏ</button>
            <button class="nt-button nt-button-warning" @click.prevent="saveDeleteItem()">Xóa</button>
          </div>
        </div>
      </div>
    </div>
    <div
      v-if="isLoader && slot_option == 1"
      style="position: absolute;left: 0px;top: 0px;width: 100%;height: 100%;background: #ffffff8a;z-index: 12;"
    >
      <div
        class="m-loader m-loader--brand m-loader--lg"
        style="width: 30px; height: 30px; display: inline-block; position:absolute; left:50%; top:50%; transform: translate(-50%, -50%)"
      ></div>
    </div>
  </div>
</template>
